#ifndef SCREEN_H_
#define SCREEN_H_

class ScreenBase;

bool init_screens();
void cleanup_screens();
void push_screen(ScreenBase *scr);
void pop_screen();

extern ScreenBase *active_screen;


class ScreenBase {
public:
	ScreenBase *next;

	ScreenBase();
	virtual ~ScreenBase();

	virtual bool init();
	virtual void destroy();

	virtual void start();
	virtual void stop();

	virtual void draw() = 0;
	virtual void reshape(int x, int y);

	virtual void keyboard(int key, bool pressed);
	virtual void mbutton(int bn, bool pressed, int x, int y);
	virtual void mmotion(int x, int y);
	virtual void mwheel(int dir, int x, int y);
};

class MenuScreen : public ScreenBase {
public:
	bool init();
	void destroy();

	void start();
	void stop();

	void draw();
	void reshape(int x, int y);

	void keyboard(int key, bool pressed);
	void mbutton(int bn, bool pressed, int x, int y);
	void mmotion(int x, int y);
};

class GameScreen : public ScreenBase {
public:
	bool init();
	void destroy();

	void draw();
	void reshape(int x, int y);

	void keyboard(int key, bool pressed);
	void mbutton(int bn, bool pressed, int x, int y);
	void mmotion(int x, int y);
	void mwheel(int dir, int x, int y);
};

#endif	// SCREEN_H_
